;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_compiler
  (foreign (include #"caml-bigloo.h"))
  (import
    (__caml_misc #"misc.scm")
    (__caml_location #"location.scm")
    (__camli_location #"location.sci")
    (__caml_parser #"parser.scm")
    (__camli_parser #"parser.sci")
    (__caml_lexer #"lexer.scm")
    (__camli_lexer #"lexer.sci")
    (__caml_modules #"modules.scm")
    (__caml_ty_decl #"ty_decl.scm")
    (__caml_pr_decl #"pr_decl.scm")
    (__caml_emit_phr #"emit_phr.scm")
    (__caml_syntax #"syntax.scm")
    (__caml_back #"back.scm")
    (__caml_front #"front.scm")
    (__caml_typing #"typing.scm")
    (__caml_ty_intf #"ty_intf.scm")
    (__caml_instruct #"instruct.scm")
    (__caml_ty_error #"ty_error.scm")
    (__caml_types #"types.scm")
    (__caml_globals #"globals.scm")
    (__caml_builtins #"builtins.scm")
    (__caml_const #"const.scm"))
  (export
    (parse_phrase_86@compiler x1)
    (3-202-parse_phrase_86@compiler x1 x2 x3)
    parse_intf_phrase_10@compiler
    parse_impl_phrase_21@compiler
    (do_directive_88@compiler x1)
    verbose_226@compiler
    (compile_intf_phrase_157@compiler x1)
    (compile_interface_171@compiler x1)
    (2-44-compile_interface_171@compiler x1 x2)
    (compile_impl_phrase_72@compiler x1)
    (2-222-compile_impl_phrase_72@compiler x1 x2)
    (compile_impl_92@compiler x1)
    (2-160-compile_impl_92@compiler x1 x2)
    write_extended_zi_52@compiler
    (compile_implementation_215@compiler x1)
    (2-234-compile_implementation_215@compiler x1 x2)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(begin
  (define parse_phrase_86@compiler
    (lambda (x1)
      (lambda (x2)
        (lambda (x3)
          (3-202-parse_phrase_86@compiler x1 x2 x3)))))
 (define 3-202-parse_phrase_86@compiler
    (lambda (x1 x2 x3)
      (letrec ((x4 (lambda (x5)
                     (let* ((:-d.handler-top1007 current_handler)
                            (:-d.1008 (unspecified)))
                       (labels
                         ((:-d.try1011
                            (:-d.1008)
                            (begin
                              (get-the-continuation :-d.1008)
                              (if (eq? #t #f)
                                (:-d.try1011 (:-d.try1011 (:-d.try1011 1))))
                              (if :-d.1008
                                (let ((x6 (x2 x3)))
                                  (labels
                                    ((:-d.staticfail1009
                                       ()
                                       (x4 (caml-make-tag 0 1))))
                                    (let ((:-d.1010 x6))
                                      (cond ((eq? :-d.1010 (caml-make-tag 6 73))
                                             (caml-make-tag 0 1))
                                            ((eq? :-d.1010
                                                  (caml-make-tag 30 73))
                                             (caml-make-tag 0 1))
                                            (else (:-d.staticfail1009))))))
                                current_handler))))
                         (let ((x6 (:-d.try1011 :-d.1008)))
                           (set! current_handler :-d.handler-top1007)
                           (if (=fx *try* 1)
                             (begin
                               (set! *try* 0)
                               (labels
                                 ((:-d.staticfail1012 () (raise x6)))
                                 (case (caml-extensible-constr-tag x6)
                                   ((lexical_error@lexer)
                                    (x4 (caml-make-tag 0 1)))
                                   (else (:-d.staticfail1012)))))
                             x6)))))))
        (let* ((:-d.handler-top1002 current_handler)
               (:-d.1003 (unspecified)))
          (labels
            ((:-d.try1004
               (:-d.1003)
               (begin
                 (get-the-continuation :-d.1003)
                 (if (eq? #t #f)
                   (:-d.try1004 (:-d.try1004 (:-d.try1004 1))))
                 (if :-d.1003 ((x1 x2) x3) current_handler))))
            (let ((x5 (:-d.try1004 :-d.1003)))
              (set! current_handler :-d.handler-top1002)
              (if (=fx *try* 1)
                (begin
                  (set! *try* 0)
                  (labels
                    ((:-d.staticfail1005 () (raise x5)))
                    (case (caml-extensible-constr-tag x5)
                      ((parse_error@parsing)
                       (let ((x6 (get_lexeme_start_200@lexing x3)))
                         (let ((x7 (get_lexeme_end_177@lexing x3)))
                           (begin
                             (if (or ((caml-constr-get-field x5 0)
                                      (caml-make-tag 6 73))
                                     ((caml-constr-get-field x5 0)
                                      (caml-make-tag 30 73)))
                               (caml-make-tag 0 1)
                               (x4 (caml-make-tag 0 1)))
                             (begin
                               (prerr_location_1@location
                                 (caml-make-regular
                                   (caml-make-tag 0 1)
                                   2
                                   x6
                                   x7))
                               (begin
                                 (prerr_begline_213@misc #" Syntax error.")
                                 (begin
                                   (prerr_endline_232@io #"")
                                   (raise 'toplevel@misc))))))))
                      ((lexical_error@lexer)
                       (begin
                         (if (and (>=fx (caml-constr-get-field x5 1) 0)
                                  (>=fx (caml-constr-get-field x5 2) 0))
                           (prerr_location_1@location
                             (caml-make-regular
                               (caml-make-tag 0 1)
                               2
                               (caml-constr-get-field x5 1)
                               (caml-constr-get-field x5 2)))
                           (caml-make-tag 0 1))
                         (begin
                           (prerr_begline_213@misc #" Lexical error: ")
                           (begin
                             (prerr_string_235@io
                               (caml-constr-get-field x5 0))
                             (begin
                               (prerr_endline_232@io #".")
                               (begin
                                 (x4 (caml-make-tag 0 1))
                                 (raise 'toplevel@misc)))))))
                      ((toplevel@misc)
                       (begin
                         (x4 (caml-make-tag 0 1))
                         (raise 'toplevel@misc)))
                      (else (:-d.staticfail1005)))))
                x5)))))))
)
(begin
  (define parse_impl_phrase_21@compiler
    ((parse_phrase_86@compiler
       implementation_42@parser)
     main_250@lexer))
 (define parse_intf_phrase_10@compiler
    ((parse_phrase_86@compiler interface_72@parser)
     main_250@lexer))
)
(define do_directive_88@compiler
  (lambda (x1)
    (labels
      ((:-d.staticfail1013
         ()
         (begin
           (prerr_begline_213@misc
             #" Warning: unknown directive \"")
           (begin
             (prerr_string_235@io
               (caml-constr-get-field x1 0))
             (prerr_endline2_160@misc #"\", ignored.")))))
      (let ((:-d.1014 (caml-constr-get-field x1 0)))
        (cond ((string=? :-d.1014 #"open")
               (begin
                 (caml-constr-set-field!
                   used_modules_84@modules
                   0
                   (cons (find_module_27@modules
                           (caml-constr-get-field x1 1))
                         (caml-constr-get-field used_modules_84@modules 0)))
                 (caml-make-tag 0 1)))
              ((string=? :-d.1014 #"close")
               (begin
                 (caml-constr-set-field!
                   used_modules_84@modules
                   0
                   ((exceptq_174@list
                      (find_module_27@modules
                        (caml-constr-get-field x1 1)))
                    (caml-constr-get-field used_modules_84@modules 0)))
                 (caml-make-tag 0 1)))
              ((string=? :-d.1014 #"infix")
               (begin
                 (add_infix_226@lexer
                   (caml-constr-get-field x1 1))
                 (caml-make-tag 0 1)))
              ((string=? :-d.1014 #"uninfix")
               (begin
                 (remove_infix_29@lexer
                   (caml-constr-get-field x1 1))
                 (caml-make-tag 0 1)))
              ((string=? :-d.1014 #"directory")
               (caml-constr-set-field!
                 load_path_99@misc
                 0
                 (cons (caml-constr-get-field x1 1)
                       (caml-constr-get-field load_path_99@misc 0))))
              (else (:-d.staticfail1013)))))))

(define verbose_226@compiler
  (caml-make-regular (caml-make-tag 0 1) 1 #f))

(define compile_intf_phrase_157@compiler
  (lambda (x1)
    (let ((x2 (caml-constr-get-field x1 0)))
      (case (caml-regular-constr-tag x2)
        ((1)
         (begin
           ((type_valuedecl_23@ty_decl
              (caml-constr-get-field x1 1))
            (caml-constr-get-field x2 0))
           (caml-make-tag 0 1)))
        ((2)
         (let ((x3 ((type_typedecl_239@ty_decl
                      (caml-constr-get-field x1 1))
                    (caml-constr-get-field x2 0))))
           (if (caml-constr-get-field verbose_226@compiler 0)
             (print_typedecl_247@pr_decl x3)
             (caml-make-tag 0 1))))
        ((3)
         (let ((x3 ((type_excdecl_123@ty_decl
                      (caml-constr-get-field x1 1))
                    (caml-constr-get-field x2 0))))
           (if (caml-constr-get-field verbose_226@compiler 0)
             (print_excdecl_200@pr_decl x3)
             (caml-make-tag 0 1))))
        (else
         (do_directive_88@compiler
           (caml-constr-get-field x2 0)))))))

(begin
  (define compile_interface_171@compiler
    (lambda (x1)
      (lambda (x2)
        (2-44-compile_interface_171@compiler x1 x2))))
 (define 2-44-compile_interface_171@compiler
    (lambda (x1 x2)
      (let ((x3 ((^_54@fstring x2) #".mli"))
            (x4 ((^_54@fstring x2) #".zi")))
        (let ((x5 (open_in_bin_161@io x3))
              (x6 (open_out_bin_83@io x4)))
          (let* ((:-d.handler-top1016 current_handler)
                 (:-d.1017 (unspecified)))
            (labels
              ((:-d.try1019
                 (:-d.1017)
                 (begin
                   (get-the-continuation :-d.1017)
                   (if (eq? #t #f)
                     (:-d.try1019 (:-d.try1019 (:-d.try1019 1))))
                   (if :-d.1017
                     (begin
                       (start_compiling_interface_242@modules x1)
                       (let ((x7 (create_lexer_channel_186@lexing x5)))
                         (begin
                           (caml-constr-set-field!
                             input_name_202@location
                             0
                             x3)
                           (begin
                             (caml-constr-set-field!
                               input_chan_27@location
                               0
                               x5)
                             (begin
                               (caml-constr-set-field!
                                 input_lexbuf_35@location
                                 0
                                 x7)
                               (begin
                                 (caml-constr-set-field!
                                   external_types_124@ty_decl
                                   0
                                   '())
                                 (let :-d.1018 ()
                                   (if #t
                                     (begin
                                       (compile_intf_phrase_157@compiler
                                         (parse_intf_phrase_10@compiler x7))
                                       (:-d.1018))
                                     '()))))))))
                     current_handler))))
              (let ((x7 (:-d.try1019 :-d.1017)))
                (set! current_handler :-d.handler-top1016)
                (if (=fx *try* 1)
                  (begin
                    (set! *try* 0)
                    (labels
                      ((:-d.staticfail1020
                         ()
                         (begin
                           (c-close_in x5)
                           (begin
                             (c-close_out x6)
                             (begin (remove_file_255@misc x4) (raise x7))))))
                      (case (caml-extensible-constr-tag x7)
                        ((end_of_file@io)
                         (begin
                           (c-close_in x5)
                           (begin
                             (write_compiled_interface_99@modules x6)
                             (c-close_out x6))))
                        (else (:-d.staticfail1020)))))
                  x7))))))))
)
(begin
  (define compile_impl_phrase_72@compiler
    (lambda (x1)
      (lambda (x2)
        (2-222-compile_impl_phrase_72@compiler x1 x2))))
 (define 2-222-compile_impl_phrase_72@compiler
    (lambda (x1 x2)
      (begin
        (reset_type_expression_vars_117@typing
          (caml-make-tag 0 1))
        (let ((x3 (caml-constr-get-field x2 0)))
          (case (caml-regular-constr-tag x3)
            ((1)
             (let ((x4 ((type_expression_168@ty_decl
                          (caml-constr-get-field x2 1))
                        (caml-constr-get-field x3 0))))
               (begin
                 (((emit_phrase_15@emit_phr x1)
                   (expr_is_pure_5@syntax
                     (caml-constr-get-field x3 0)))
                  ((compile_lambda_215@back #f)
                   (translate_expression_98@front
                     (caml-constr-get-field x3 0))))
                 (if (caml-constr-get-field verbose_226@compiler 0)
                   (print_expr_98@pr_decl x4)
                   (caml-make-tag 0 1)))))
            ((2)
             (let ((x4 (((type_letdef_82@ty_decl
                           (caml-constr-get-field x2 1))
                         (caml-constr-get-field x3 0))
                        (caml-constr-get-field x3 1))))
               (begin
                 (((emit_phrase_15@emit_phr x1)
                   (letdef_is_pure_151@syntax
                     (caml-constr-get-field x3 1)))
                  (if (caml-constr-get-field x3 0)
                    ((compile_lambda_215@back #t)
                     ((translate_letdef_rec_253@front
                        (caml-constr-get-field x2 1))
                      (caml-constr-get-field x3 1)))
                    ((compile_lambda_215@back #f)
                     ((translate_letdef_153@front
                        (caml-constr-get-field x2 1))
                      (caml-constr-get-field x3 1)))))
                 (if (caml-constr-get-field verbose_226@compiler 0)
                   (print_valdef_178@pr_decl x4)
                   (caml-make-tag 0 1)))))
            ((3)
             (let ((x4 ((type_typedecl_239@ty_decl
                          (caml-constr-get-field x2 1))
                        (caml-constr-get-field x3 0))))
               (if (caml-constr-get-field verbose_226@compiler 0)
                 (print_typedecl_247@pr_decl x4)
                 (caml-make-tag 0 1))))
            ((4)
             (let ((x4 ((type_excdecl_123@ty_decl
                          (caml-constr-get-field x2 1))
                        (caml-constr-get-field x3 0))))
               (if (caml-constr-get-field verbose_226@compiler 0)
                 (print_excdecl_200@pr_decl x4)
                 (caml-make-tag 0 1))))
            (else
             (do_directive_88@compiler
               (caml-constr-get-field x3 0))))))))
)
(begin
  (define compile_impl_92@compiler
    (lambda (x1)
      (lambda (x2)
        (2-160-compile_impl_92@compiler x1 x2))))
 (define 2-160-compile_impl_92@compiler
    (lambda (x1 x2)
      (let ((x3 ((^_54@fstring x2) #".ml"))
            (x4 ((^_54@fstring x2) #".zo")))
        (let ((x5 (open_in_bin_161@io x3))
              (x6 (open_out_bin_83@io x4)))
          (let ((x7 (create_lexer_channel_186@lexing x5)))
            (begin
              (caml-constr-set-field!
                input_name_202@location
                0
                x3)
              (begin
                (caml-constr-set-field!
                  input_chan_27@location
                  0
                  x5)
                (begin
                  (caml-constr-set-field!
                    input_lexbuf_35@location
                    0
                    x7)
                  (begin
                    (start_emit_phrase_36@emit_phr x6)
                    (let* ((:-d.handler-top1022 current_handler)
                           (:-d.1023 (unspecified)))
                      (labels
                        ((:-d.try1025
                           (:-d.1023)
                           (begin
                             (get-the-continuation :-d.1023)
                             (if (eq? #t #f)
                               (:-d.try1025 (:-d.try1025 (:-d.try1025 1))))
                             (if :-d.1023
                               (let :-d.1024 ()
                                 (if #t
                                   (begin
                                     ((compile_impl_phrase_72@compiler x6)
                                      (parse_impl_phrase_21@compiler x7))
                                     (:-d.1024))
                                   '()))
                               current_handler))))
                        (let ((x8 (:-d.try1025 :-d.1023)))
                          (set! current_handler :-d.handler-top1022)
                          (if (=fx *try* 1)
                            (begin
                              (set! *try* 0)
                              (labels
                                ((:-d.staticfail1026
                                   ()
                                   (begin
                                     (c-close_in x5)
                                     (begin
                                       (c-close_out x6)
                                       (begin
                                         (remove_file_255@misc x4)
                                         (raise x8))))))
                                (case (caml-extensible-constr-tag x8)
                                  ((end_of_file@io)
                                   (begin
                                     (end_emit_phrase_38@emit_phr x6)
                                     (begin (c-close_in x5) (c-close_out x6))))
                                  (else (:-d.staticfail1026)))))
                            x8)))))))))))))
)
(define write_extended_zi_52@compiler
  (caml-make-regular (caml-make-tag 0 1) 1 #f))

(begin
  (define compile_implementation_215@compiler
    (lambda (x1)
      (lambda (x2)
        (2-234-compile_implementation_215@compiler x1 x2))))
 (define 2-234-compile_implementation_215@compiler
    (lambda (x1 x2)
      (begin
        (caml-constr-set-field!
          external_types_124@ty_decl
          0
          '())
        (if (file_exists_172@misc
              ((^_54@fstring x2) #".mli"))
          (let* ((:-d.handler-top1032 current_handler)
                 (:-d.1033 (unspecified)))
            (labels
              ((:-d.try1038
                 (:-d.1033)
                 (begin
                   (get-the-continuation :-d.1033)
                   (if (eq? #t #f)
                     (:-d.try1038 (:-d.try1038 (:-d.try1038 1))))
                   (if :-d.1033
                     (let ((x3 (read_module_102@modules
                                 ((^_54@fstring x2) #".zi"))))
                       (begin
                         ((start_compiling_implementation_91@modules x1)
                          x3)
                         (begin
                           (enter_interface_definitions_230@ty_intf x3)
                           (begin
                             ((compile_impl_92@compiler x1) x2)
                             (begin
                               (check_interface_106@ty_intf x3)
                               (begin
                                 (if (caml-constr-get-field
                                       write_extended_zi_52@compiler
                                       0)
                                   (let ((x4 ((^_54@fstring x2) #".zix")))
                                     (let ((x5 (open_out_bin_83@io x4)))
                                       (let* ((:-d.handler-top1035
                                                current_handler)
                                              (:-d.1036 (unspecified)))
                                         (labels
                                           ((:-d.try1037
                                              (:-d.1036)
                                              (begin
                                                (get-the-continuation :-d.1036)
                                                (if (eq? #t #f)
                                                  (:-d.try1037
                                                    (:-d.try1037
                                                      (:-d.try1037 1))))
                                                (if :-d.1036
                                                  (begin
                                                    (write_compiled_interface_99@modules
                                                      x5)
                                                    (c-close_out x5))
                                                  current_handler))))
                                           (let ((x6 (:-d.try1037 :-d.1036)))
                                             (set! current_handler
                                               :-d.handler-top1035)
                                             (if (=fx *try* 1)
                                               (begin
                                                 (set! *try* 0)
                                                 (begin
                                                   (c-close_out x5)
                                                   (begin
                                                     (remove_file_255@misc x4)
                                                     (raise x6))))
                                               x6))))))
                                   (caml-make-tag 0 1))
                                 (kill_module_137@modules x1)))))))
                     current_handler))))
              (let ((x3 (:-d.try1038 :-d.1033)))
                (set! current_handler :-d.handler-top1032)
                (if (=fx *try* 1)
                  (begin
                    (set! *try* 0)
                    (begin
                      (remove_file_255@misc ((^_54@fstring x2) #".zo"))
                      (raise x3)))
                  x3))))
          (let ((x3 ((^_54@fstring x2) #".zi")))
            (let ((x4 (open_out_bin_83@io x3)))
              (let* ((:-d.handler-top1028 current_handler)
                     (:-d.1029 (unspecified)))
                (labels
                  ((:-d.try1030
                     (:-d.1029)
                     (begin
                       (get-the-continuation :-d.1029)
                       (if (eq? #t #f)
                         (:-d.try1030 (:-d.try1030 (:-d.try1030 1))))
                       (if :-d.1029
                         (begin
                           (start_compiling_interface_242@modules x1)
                           (begin
                             ((compile_impl_92@compiler x1) x2)
                             (begin
                               (write_compiled_interface_99@modules x4)
                               (c-close_out x4))))
                         current_handler))))
                  (let ((x5 (:-d.try1030 :-d.1029)))
                    (set! current_handler :-d.handler-top1028)
                    (if (=fx *try* 1)
                      (begin
                        (set! *try* 0)
                        (begin
                          (c-close_out x4)
                          (begin (remove_file_255@misc x3) (raise x5))))
                      x5))))))))))
)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
