;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_pair
  (foreign (include #"caml-bigloo.h"))
  (import)
  (export
    (split_219@pair x1)
    (combine_207@pair x1)
    (map_combine_74@pair x1)
    (do_list_combine_121@pair x1)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(define split_219@pair
  (lambda (x1)
    (if (null? x1)
      (caml-make-regular (caml-make-tag 0 1) 2 '() '())
      (let ((x2 (split_219@pair (cdr x1))))
        (caml-make-regular
          (caml-make-tag 0 1)
          2
          (cons (caml-constr-get-field (car x1) 0)
                (caml-constr-get-field x2 0))
          (cons (caml-constr-get-field (car x1) 1)
                (caml-constr-get-field x2 1)))))))

(define combine_207@pair
  (lambda (x1)
    (labels
      ((:-d.staticfail1001
         ()
         (invalid_arg_209@exc #"combine")))
      (if (null? (caml-constr-get-field x1 0))
        (if (null? (caml-constr-get-field x1 1))
          '()
          (:-d.staticfail1001))
        (if (null? (caml-constr-get-field x1 1))
          (:-d.staticfail1001)
          (cons (caml-make-regular
                  (caml-make-tag 0 1)
                  2
                  (car (caml-constr-get-field x1 0))
                  (car (caml-constr-get-field x1 1)))
                (combine_207@pair
                  (caml-make-regular
                    (caml-make-tag 0 1)
                    2
                    (cdr (caml-constr-get-field x1 0))
                    (cdr (caml-constr-get-field x1 1))))))))))

(define map_combine_74@pair
  (lambda (x1)
    (letrec ((x2 (lambda (x3)
                   (labels
                     ((:-d.staticfail1002
                        ()
                        (invalid_arg_209@exc #"map_combine")))
                     (if (null? (caml-constr-get-field x3 0))
                       (if (null? (caml-constr-get-field x3 1))
                         '()
                         (:-d.staticfail1002))
                       (if (null? (caml-constr-get-field x3 1))
                         (:-d.staticfail1002)
                         (cons (x1 (caml-make-regular
                                     (caml-make-tag 0 1)
                                     2
                                     (car (caml-constr-get-field x3 0))
                                     (car (caml-constr-get-field x3 1))))
                               (x2 (caml-make-regular
                                     (caml-make-tag 0 1)
                                     2
                                     (cdr (caml-constr-get-field x3 0))
                                     (cdr (caml-constr-get-field x3 1)))))))))))
      x2)))

(define do_list_combine_121@pair
  (lambda (x1)
    (letrec ((x2 (lambda (x3)
                   (labels
                     ((:-d.staticfail1003
                        ()
                        (invalid_arg_209@exc #"do_list_combine")))
                     (if (null? (caml-constr-get-field x3 0))
                       (if (null? (caml-constr-get-field x3 1))
                         (caml-make-tag 0 1)
                         (:-d.staticfail1003))
                       (if (null? (caml-constr-get-field x3 1))
                         (:-d.staticfail1003)
                         (begin
                           (x1 (caml-make-regular
                                 (caml-make-tag 0 1)
                                 2
                                 (car (caml-constr-get-field x3 0))
                                 (car (caml-constr-get-field x3 1))))
                           (x2 (caml-make-regular
                                 (caml-make-tag 0 1)
                                 2
                                 (cdr (caml-constr-get-field x3 0))
                                 (cdr (caml-constr-get-field x3 1)))))))))))
      x2)))

(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
(unspecified)
